#!/bin/env python
# -*- coding: utf-8 -*-

import sys
import argparse
import os
import filecmp
import subprocess
import platform
import webbrowser
import configparser
import pathlib


print(
    "************************************************************\n"
    "如果下面报告类似 ImportError: No module named 'xxx' 的错误，\n"
    "说明 python 运行环境中缺少必要的包。\n"
    "此时可以启动\"安装python包\"任务来修复 python 运行环境(需要连接互联网)。\n"
    "************************************************************\n"
    )

from colorama import Fore, init, AnsiToWin32
init(wrap=False)

stream = AnsiToWin32(sys.stderr).stream

if __name__ == "__main__":

    print("gitpush.py version: 1.0")
    execResult = os.system("git config credential.helper \"\" && git add . && git commit -m \"提交作业\"")

    if execResult == 256 or  execResult == 1:
        print("\n-------- 本次提交没有任何变更，即使推送成功，也不代表远程一定有提交记录 --------")
        print("-------- 请对项目中的文件进行修改后再进行提交-----------------------------------")
    elif  execResult != 0:
        print(Fore.RED + "\n-------- 提交作业失败! 错误码: {0}--------".format(execResult), file = stream)
        print(Fore.WHITE, file = stream)
        exit(0)
    print("\n-------------------------------------------------------------------------------")
    print("请在 VSCode 顶部弹出的命令面板中输入 Git 远程库的用户名和密码。通常为 CodeCode  平台的用户名和密码。")
    print("-------------------------------------------------------------------------------")

    execResult = os.system("git push")
    if execResult == 0:
        print(Fore.GREEN + "\n-------- 提交作业成功！ --------", file = stream)
        print(Fore.WHITE, file = stream)
   
        strGitconfigPath = ""
        if platform.system().lower() == 'windows':
            strGitconfigPath = ".\\.git\\config" 
        else:
            strGitconfigPath = "./.git/config"
        path = pathlib.Path(strGitconfigPath)
        strGitLabCIPath = ".gitlab-ci.yml"
        gitlabciPath = pathlib.Path(strGitLabCIPath)
        # 判断是否存在.git/config文件
        if path.exists() and path.is_file() and gitlabciPath.exists() and gitlabciPath.is_file():
            #  实例化configParser对象
            config = configparser.ConfigParser()
            config.read(strGitconfigPath, encoding='UTF-8')
            pipelines_url = config.get('remote \"origin\"', 'url').replace(".git", "/pipelines")
            print("正在使用浏览器打开流水线页面，或者点击", pipelines_url)
            webbrowser.open(pipelines_url)
    else:
        print(Fore.RED + "\n--- 提交作业失败! 想解决失败问题？ 使用浏览器访问下面链接即可。 ---", file = stream)
        print(Fore.RED + "https://www.codecode.net/engintime/codecode/publicmanual/blob/master/GitFAQ.md", file = stream)
        print(Fore.WHITE, file = stream)


    